//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Red
#property indicator_color2     LimeGreen
#property indicator_color3     Aqua
#property indicator_color4     DeepPink
#property indicator_levelstyle STYLE_DASHDOTDOT
#property indicator_levelcolor Gold

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern double BullBearPeriod  = 100;
extern int    BullBearPrice   = 5;
extern bool   ShowArrows      = true;
extern bool   ArrowOnLast     = false;
extern int    arrowSize       = 1;

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double bears[];
double bulls[];
double arrowUp[];
double arrowDn[];
double nlm[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
  {
   IndicatorBuffers(6);   
   SetIndexBuffer(0,bears);
   SetIndexBuffer(1,bulls);
   SetIndexBuffer(2,arrowUp); 
   SetIndexBuffer(3,arrowDn); 
   SetIndexBuffer(4,nlm);
   SetIndexBuffer(5,trend);
   SetLevelValue(0,0);
   
   if (ShowArrows)
    {
      SetIndexStyle(2,DRAW_ARROW,0,arrowSize); SetIndexArrow(2,233);
      SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,233);
    }
    else
    {
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
    }
   
      //
      //
      //
      //
      //
     
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
     
     //
     //
     //
     //
     //
   
     IndicatorShortName(timeFrameToString(timeFrame)+"   NonLag BullsBears ("+DoubleToStr(BullBearPeriod,2)+")");
return(0);
}

//
//
//
//
//

int deinit()
{
      
return(0); 
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bears[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
     for (i=limit; i>=0; i--)
     {
        nlm[i]   = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,BullBearPrice,i),BullBearPeriod,i,0);
        bears[i] = nlm[i]  - Low[i];
        bulls[i] = High[i] - nlm[i];
        trend[i]   = trend[i+1];
        arrowUp[i] = EMPTY_VALUE;
        arrowDn[i] = EMPTY_VALUE;
           if (bulls[i] > bears[i]) trend[i] = 1;
           if (bulls[i] < bears[i]) trend[i] =-1;
           if (trend[i] != trend[i+1])
           if (trend[i]==1) 
                 arrowUp[i] = bulls[i];
           else  arrowDn[i] = bears[i];
      
     }
     manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   int displace = 1; if (ArrowOnLast) displace=-1;
   for (i=limit; i>=0; i--)
   {  
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+displace]); 
         bears[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullBearPeriod,BullBearPrice,0,y);
         bulls[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullBearPeriod,BullBearPrice,1,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullBearPeriod,BullBearPrice,5,y);
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
          if (x!=y)
          {
            int z = iBarShift(NULL,0,iTime(NULL,timeFrame,y+1));
            if (trend[i] != trend[z])
               if (trend[i]==1) 
                     arrowUp[i] = bulls[i];
               else  arrowDn[i] = bears[i];
          }
         
    }
    manageAlerts();
return(0);
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

double  nlm.values[3][1];
double  nlm.prices[ ][1];
double  nlm.alphas[ ][1];

//
//
//
//
//

double iNonLagMa(double price, double length, int r, int instanceNo=0)
{
   r = Bars-r-1;
   if (ArrayRange(nlm.prices,0) != Bars) ArrayResize(nlm.prices,Bars);
                               nlm.prices[r][instanceNo]=price;
   if (length<3 || r<3) return(nlm.prices[r][instanceNo]);
   
   //
   //
   //
   //
   //
   
   if (nlm.values[_length][instanceNo] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
         nlm.values[_length][instanceNo] = length;
         nlm.values[_len   ][instanceNo] = length*4 + Phase;  
         nlm.values[_weight][instanceNo] = 0;

         if (ArrayRange(nlm.alphas,0) < nlm.values[_len][instanceNo]) ArrayResize(nlm.alphas,nlm.values[_len][instanceNo]);
         for (int k=0; k<nlm.values[_len][instanceNo]; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlm.alphas[k][instanceNo]        = g * beta;
            nlm.values[_weight][instanceNo] += nlm.alphas[k][instanceNo];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (nlm.values[_weight][instanceNo]>0)
   {
      double sum = 0;
           for (k=0; k < nlm.values[_len][instanceNo]; k++) sum += nlm.alphas[k][instanceNo]*nlm.prices[r-k][instanceNo];
           return( sum / nlm.values[_weight][instanceNo]);
   }
   else return(0);           
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" nonlag bullbears trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" nonlag bullbears ",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

